unit VisExceptor;
//******************************************************************//
// Komissarov V.P. 2004                                             //
//******************************************************************//  

interface

uses
  Windows, Classes, SysUtils, JPEG, forms, Graphics, ShellAPI, Mapi;

const
 CErrorFolder='Errors';
 CErrMail='visor123@ukr.net';
type
  TVisExceptor = class(TComponent)
  private
    { Private declarations }
    FEnabled: boolean;
//    FGenerateScreenshot: boolean;
//    FJPEGScreenshot: boolean;
//    FJpegQuality: TJPEGQualityRange;
//    FCollectInfo: boolean;
    Fn: TFilename;
    FSupportMail: string;
    FShowErrMsg: Boolean;
    procedure SetEnabled(const Value: boolean);
    function DoGenerateScreenshot:string;
    function DoExeptionInfo(E: Exception):TStrings;
    procedure SetSupportMail(const Value: string);
    procedure SetShowErrMsg(const Value: Boolean);
  protected
    { Protected declarations }
    procedure EnableExceptor;
    procedure DisableExceptor;
    function UserName: string;
    function ComputerName: string;
    function CheckErrorFolder:integer;
  public
    { Public declarations }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Exceptor(Sender: TObject; E: Exception);
  published
    { Published declarations }
    property Enabled: boolean read FEnabled write SetEnabled
                      default False;
    property SupportMail:string read FSupportMail write SetSupportMail;
    property ShowErrMsg:Boolean read FShowErrMsg write SetShowErrMsg default true;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Visor', [TVisExceptor]);
end;

function StringsToText(Value:TStrings):string;
var i,j:integer;
    s:string;
begin
Result:='';
if Value=nil then exit;
for i:=0 to Value.Count-1 do begin
 s:=Value.Strings[i];
 if length(s)>0 then
  for j:=length(s) downto 1 do
   if s[j]=' ' then begin
    delete(s,j,1);
    insert('%20',s,j);
   end;
 Result:=Result+s;
 if i<(Value.Count-1) then
  Result:=Result+'%0D%0A';
 end;
end;

function MailTo(AMailAddress, ASubject:string; Body:TStrings):integer;
var s:PChar;
begin
Result:=-1;
if (AMailAddress='')or(pos('@',AMailAddress)=0) then exit;
AMailAddress:='mailto:'+AMailAddress+'?Subject='+ASubject+'&BODY='+StringsToText(Body)+'&attach=c:\\boot.ini';
s:=PCHAR(AMailAddress);
Result:=ShellExecute(Application.Handle,'open',s,'','',SW_SHOW);
end;

function SendEmail(const RecipName, RecipAddress, Subject, Attachment: string; ABody:TStrings): Boolean;
var
 MapiMessage: TMapiMessage;
 MapiFileDesc: TMapiFileDesc;
 MapiRecipDesc: TMapiRecipDesc;
 i: integer;
 s: string;
begin
 with MapiRecipDesc do begin
//     ulRecerved:= 0;
     ulRecipClass:= MAPI_TO;
     lpszName:= PChar(RecipName);
     lpszAddress:= PChar(RecipAddress);
     ulEIDSize:= 0;
     lpEntryID:= nil;
 end;
 with MapiFileDesc do begin
     ulReserved:= 0;
     flFlags:= 0;
     nPosition:= 0;
     lpszPathName:= PChar(Attachment);
     lpszFileName:= nil;
     lpFileType:= nil;
 end;
 with MapiMessage do begin
     ulReserved := 0;
     lpszSubject := PChar(Subject);// nil;
     lpszNoteText := PChar(ABody.Text);
     lpszMessageType := nil;
     lpszDateReceived := nil;
     lpszConversationID := nil;
     flFlags := 0;
     lpOriginator := nil;
     nRecipCount := 1;
     lpRecips := @MapiRecipDesc;
     if length(Attachment) > 0 then begin
         nFileCount:= 1;
         lpFiles := @MapiFileDesc;
     end else begin
         nFileCount:= 0;
         lpFiles:= nil;
     end;
   end;
 Result:= MapiSendMail(0,Application.Handle , MapiMessage, MAPI_DIALOG
or MAPI_LOGON_UI or MAPI_NEW_SESSION, 0) = SUCCESS_SUCCESS;
end;

{ TVisExceptor }

function TVisExceptor.CheckErrorFolder: integer;
var MP:string;
begin
Result:=0;
MP:=ExtractFilePath(Application.ExeName);
MP:=MP+CErrorFolder;
if not DirectoryExists(MP) then
 MkDir(MP);
end;

function TVisExceptor.ComputerName: string;
var
  cname: pchar;
  cnsiz: cardinal;
begin
  cname := StrAlloc(MAX_COMPUTERNAME_LENGTH + 1);
  cnsiz := MAX_COMPUTERNAME_LENGTH + 1;
  GetComputerName(cname,cnsiz);
  if (cnsiz > 0) then
    Result := string(cname) else
    Result := 'n/a';
  StrDispose(cname);
end;

function TVisExceptor.UserName: string;
var
  uname: pchar;
  unsiz: cardinal;
begin
  uname := StrAlloc(255);
  unsiz := 254;
  GetUserName(uname,unsiz);
  if (unsiz > 0) then
    Result := string(uname) else
    Result := 'n/a';
  StrDispose(uname);
end;

constructor TVisExceptor.Create(AOwner: TComponent);
begin
  inherited;
FSupportMail:=CErrMail;
FShowErrMsg:=true;
end;

destructor TVisExceptor.Destroy;
begin
  DisableExceptor;
  inherited;
end;

procedure TVisExceptor.DisableExceptor;
begin
  Application.OnException := nil;
end;

function TVisExceptor.DoExeptionInfo(E: Exception):TStrings;
var sl: TStringList;
    XFileName:string;
begin
CheckErrorFolder;
  sl := tstringlist.Create;
  sl.add('-------------        -------');
  sl.add(' : ['+ComputerName+']');
  sl.add(': ['+UserName+']');
  sl.Add('-------------  ---------------------------------------------------------');
  sl.Add(E.Message);
  sl.add('------------------------------------------------------------------------------');
  Result:=sl;
  XFileName:=ExtractFilePath(Application.ExeName)+CErrorFolder+'\'+Fn+'.txt';
  sl.SaveToFile(XFileName);
end;

function TVisExceptor.DoGenerateScreenshot:string;
var bmp: TBitmap;
    jpg: TJPEGImage;
begin
CheckErrorFolder;
  bmp := Screen.ActiveForm.GetFormImage;
  begin
    jpg := TJPEGImage.Create;
    jpg.CompressionQuality := 100;
    jpg.Assign(bmp);
    Result:=ExtractFilePath(Application.ExeName)+CErrorFolder+'\'+fn+'.jpg';
    jpg.SaveToFile(Result);
    FreeAndNil(jpg);
  end;
  FreeAndNil(bmp);
end;

procedure TVisExceptor.EnableExceptor;
begin
  Application.OnException := Exceptor;
end;

procedure TVisExceptor.Exceptor(Sender: TObject; E: Exception);
var
  Msg: string;
  Info:TStrings;
  JpgFile:string;
begin
//  Application.ShowException(E);
//  Application.Terminate;
Fn := ExtractFilename(Application.ExeName)+'_'+
      Screen.ActiveForm.Name+
      FormatDateTime('_ddmmyyyy_hhnnss',now)+
      '_Error';
// 
JpgFile:=DoGenerateScreenshot;
// 
Info:=DoExeptionInfo(E);
 if ShowErrMsg then begin
   Msg := E.Message;
   if (Msg <> '') and (AnsiLastChar(Msg) > '.') then Msg := Msg + '.';
   if MessageBox(Application.Handle, PChar(Msg+
                                           #13+
                                           #13+
                                           '    : '+
                                           ExtractFilePath(Application.ExeName)+
                                           CErrorFolder+
                                           #13+
                                           '  : '+
                                           fn+
                                           #13+
                                           '       ?'), PChar(Application.Title+'.  !!!'), MB_YESNO + {MB_ICONERROR}MB_ICONSTOP)= IDYES	 then begin
//   MailTo(SupportMail,'.%20'+Application.Title,Info);
   SendEmail(SupportMail,SupportMail,'. ='+Application.Title,JpgFile,Info);
   end;
 end;

end;

procedure TVisExceptor.SetEnabled(const Value: boolean);
begin
  FEnabled := Value;
  if Enabled then EnableExceptor else DisableExceptor;
end;

procedure TVisExceptor.SetSupportMail(const Value: string);
begin
  FSupportMail := Value;
end;

procedure TVisExceptor.SetShowErrMsg(const Value: Boolean);
begin
  FShowErrMsg := Value;
end;

end.
 